use utf8;
use Time::HiRes qw(gettimeofday);

sub get_datetime {
	my $t;
	my $msec = ' ';
	if ($ifo{'sec'}) {
		($t,$msec) = gettimeofday;
		$msec = '.'.substr($msec,0,$ifo{'sec'}).' ';
	} else {
		$t = time;
	}
	$t += $ifo{'time'} + 32400;
	my @youbi = ('日', '月', '火', '水', '木', '金', '土');
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($t);
	$year += 1900;
	$mon += 1;
	my $ret = sprintf("%04d/%02d/%02d(",$year,$mon,$mday);
	$ret .= enc_str($youbi[$wday]);
	$ret .= sprintf(") %02d:%02d:%02d",$hour,$min,$sec).$msec;
	$day = $yday;
	$omday = $mday;
	return($ret);
}

sub get_date {
	my $t = time;
	my $msec;
	if ($ifo{'sec'}) {($t,$msec) = gettimeofday;}
	$t += $ifo{'time'} + 32400;
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($t);
	$mon += 1;
	$year %= 100;
	my $ret = sprintf("%02d/%02d/%02d",$year,$mon,$mday);
	return($ret);
}

sub html_spchar {	#&と'の変換はしない
	my $text = shift;
	$$text =~ s/"/&quot;/g;	#"の変換
	$$text =~ s/</&lt;/g;	#<の変換
	$$text =~ s/>/&gt;/g;	#>の変換
	$$text =~ s/\n|\r\n|\r/<br>/g;	#改行の変換
}

1;
