use utf8;
use File::Path;
use File::Copy;

sub move_kako {
	my $count = shift;	#過去ログ倉庫へ移動するスレッド数
	my $thread = get_max_thread($bbs);
	if ($count < 1 || $thread < 1) {return(0);}
	my $from = $bbs;
	my $to = $from.'_kako';
	my @list;
	while ($count > 0) {
		my $tmp = pop(@sbj_txt);
		push(@list,$tmp);
		$count--;
	}
	move_kako_th($from,$to,@list);
	return(1);
}

sub move_kako_th {
	my $from = shift;
	my $to = shift;
	my @move_list = @_;
	my @del_list;
	my @kako_list;
	my $to_kako = 0;

	if (index($from,'_kako') < 0) {
		foreach $data(@move_list) {
			my ($key,$name) = split('.dat<>',$data);
			thread_mode("../$from/idx/$key.idx",0);
		}
	}
	if ($ifo{'max_kako'} || index($to,'_kako') < 0) {	#ボード間移動
		@move_list = del_subject($from,@move_list);
		@del_list = add_subject($to,@move_list);
	} else {	#過去ログ倉庫が無いから削除
		open(SBJ,"+<../$from/subject.txt");
		flock(SBJ,2);
		seek(SBJ,0,0);
		foreach $data(@sbj_txt) {
			print SBJ $data;
		}
		truncate(SBJ,tell(SBJ));
		close(SBJ);
		del_thread($from,@move_list);
		return(0);
	}
	if (index($to,'_kako') < 0 && $ifo{'max_kako'}) {	#移動先が過去ログ倉庫ではない
		$to_kako = $to.'_kako';
		@kako_list = add_subject($to_kako,@del_list);
	}
	if ($to_kako) {
		foreach $data(@del_list) {
			my ($key,$name) = split('.dat<>',$data);
			thread_mode("../$to/idx/$key.idx",0);
		}
		del_thread($to_kako,@kako_list);
		move_thread($to,$to_kako,@del_list);
	} else {
		del_thread($to,@del_list);
	}
	return(move_thread($from,$to,@move_list));
}

sub del_subject {
	my $board = shift;
	my @dat_name = @_;
	my $end = @dat_name;
	my $cnt;
	my @list;
	unless ($end) {return(@list);}
	for ($cnt =0;$cnt < $end;$cnt++) {
		$dat_name[$cnt] = substr($dat_name[$cnt],0,index($dat_name[$cnt],'<>'));
	}
	my @sbj_txt;
	my @new_sbj;
	if (open (SBJ,"+<../$board/subject.txt")) {
		flock(SBJ,2);
		@sbj_txt = <SBJ>;
		my $flg;
		foreach $data(@sbj_txt) {
			$flg = 1;
			for($cnt = 0;$cnt < $end;$cnt++) {
				if (index($data,$dat_name[$cnt]) == 0) {
					$flg = 0;
					push(@list,$data);
					last;
				}
			}
			if ($flg) {push(@new_sbj,$data);}
		}
		seek(SBJ,0,0);
		foreach $data(@new_sbj) {
			print SBJ $data;
		}
		truncate(SBJ,tell(SBJ));
		close(SBJ);
	}
	return(@list);
}

sub add_subject {
	my $board = shift;
	my @dat_name = @_;
	my @ret;
	my $cnt = @dat_name;
	unless($cnt) {return(@ret);}
	open(SBJ,"+<../$board/subject.txt");
	flock(SBJ,2);
	my @list = @dat_name;
	while(<SBJ>) {
		my $sbj = $_;
		my $flg =1;
		foreach $data(@dat_name) {
			my ($dat) = split('<>',$data);
			if (index($sbj,$dat) == 0) {
				$flg = 0;
				last;
			}
		}
		if ($flg) {push(@list,$_);}
	}
	$cnt = @list;
	if (index($board,'_kako') >= 0) {
		$cnt = ($ifo{'max_kako'} > 0 ? $cnt - $ifo{'max_kako'} : 0);
	} else {
		my $thread = get_max_thread($board);
		$cnt = ($thread > 0 ? $cnt - $thread : 0);
	}
	while($cnt > 0) {
		my $tmp = pop(@list);
		unshift(@ret,$tmp);
		$cnt--;
	}
	seek(SBJ,0,0);
	foreach $data(@list) {
		print SBJ $data;
	}
	truncate(SBJ,tell(SBJ));
	close(SBJ);
	return(@ret);
}

sub del_thread {
	my $board = shift;
	my @key = dat_to_key(@_);
	my $cnt = 0;
	foreach $data(@key) {
		unlink("../$board/dat/$data.dat");
		unlink("../$board/idx/$data.idx");
		unlink("../$board/ifo/$data.cgi");
		if (-d "../$board/img/$data") {rmtree("../$board/img/$data");}
		if (-d "../$board/smn/$data") {rmtree("../$board/smn/$data");}
		$cnt++;
	}
	return($cnt);
}

sub move_thread {
	my $from = shift;
	my $to = shift;
	my @key = dat_to_key(@_);
	my $cnt = 0;
	foreach $data(@key) {
		move_dat($from,$to,$data);
		move("../$from/ifo/$data.cgi","../$to/ifo/$data.cgi");
		if (-d "../$from/img/$data") {move("../$from/img/$data","../$to/img/$data");}
		if (-d "../$from/smn/$data") {move("../$from/smn/$data","../$to/smn/$data");}
		$cnt++;
	}
	return($cnt);
}

sub move_dat {
	my $from = shift;
	my $to = shift;
	my $key = shift;
	my $top = get_top();
	open(IN,"<../$from/dat/$key.dat") or return(0);
	flock(IN,1);
	unless (open(OUT,">../$to/dat/$key.dat")) {
		close(IN);
		return(0);
	}
	flock(OUT,2);
	while(<IN>) {
		my ($name,$mail,$info,$message,$title) = split('<>',$_);
		my $pic_str = "$top$from/img/$key/";
		if (index($message,$pic_str) == 0) {
			substr($message,0,length($pic_str),"$top$to/img/$key/");
		}
		$message =~ s/(<a href=\"\.\.\/test\/read\.cgi\/)$from\//$1$to\//g;
		print OUT "$name<>$mail<>$info<>$message<>$title";
	}
	close(OUT);
	close(IN);
	unlink("../$from/idx/$key.idx","../$from/dat/$key.dat");
	write_idx($to,$key);
}

sub write_idx {
	my $board = shift;
	my $dat = shift;
	my $sgn = 1;
	if (index($board,'_kako') >= 0) {$sgn = -1;}
	open(LOG,"<../$board/dat/$dat.dat") or return(0);
	flock(LOG,1);
	unless (open(IDX,">../$board/idx/$dat.idx")) {
		close(LOG);
		return(0);
	}
	flock(IDX,2);
	binmode(IDX);
	my $count = 0;
	my $buf = pack("l",0);
	print IDX $buf;
	while(<LOG>) {
		$buf = pack("l",tell(LOG));
		print IDX $buf;
		$count++;
	}
	seek(IDX,0,0);
	truncate(IDX, $count * 4);
	if (tell(LOG) >= ($ifo{'max_dat_size'} * 1024)) {$sgn = -1;}
	if ($count >= $ifo{'max_res'}) {$sgn = -1;}
	$buf = pack("l",$count * $sgn);
	print IDX $buf;
	close(LOG);
	close(IDX);
}

sub dat_to_key {
	my @dat_name = @_;
	my @list;
	foreach $data(@dat_name) {
		my $tmp = substr($data,0,index($data,'.dat'));
		push(@list,$tmp);
	}
	return(@list);
}

sub get_max_thread {
	my $board = shift;
	my %set = get_setting_txt($board);
	my $thread = $set{'MAX_THREAD'};
	if ($thread <= 0) {$thread = $ifo{'max_thread'};}
	if ($thread <= 0) {$thread = 0;}
	return($thread);
}
1;